#include <sys/file.h>
#include <stdio.h>
#include <string.h>
#include "plcm_ioctl.h"

int main(int argc, char *argv[])
{
	int devfd;
	char clean_buffer[20];

	memset(clean_buffer, 0x20, sizeof(clean_buffer));

	iopl(3);
	devfd = open("/dev/plcm_drv", O_RDWR);

	if (devfd == -1)
	{
		printf("Open fail\n");
		return -1;
	}

	ioctl(devfd, PLCM_IOCTL_DISPLAY_D, 1);
	ioctl(devfd, PLCM_IOCTL_DISPLAY_B, 0);
	ioctl(devfd, PLCM_IOCTL_DISPLAY_C, 0);

	ioctl(devfd, PLCM_IOCTL_SET_LINE, 1);
	write(devfd, clean_buffer, sizeof(clean_buffer));
	ioctl(devfd, PLCM_IOCTL_SET_LINE, 2);
	write(devfd, clean_buffer, sizeof(clean_buffer));
	ioctl(devfd, PLCM_IOCTL_RETURNHOME, 0);

	char top_left[20];
	char top_right[20];
	char bottom_left[20];
	char bottom_right[20];

	FILE *fp;

	fp = fopen("top-left", "r");
	if (fp == NULL)
	{
		printf("Could not open file!\n");
		return 1;
	}

	fgets(top_left, 20, fp);
	strtok(top_left, "\n");

	fp = fopen("top-right", "r");
	if (fp == NULL)
	{
		printf("Could not open file!\n");
		return 1;
	}

	fgets(top_right, 20, fp);
	strtok(top_right, "\n");

	fp = fopen("bottom-left", "r");
	if (fp == NULL)
	{
		printf("Could not open file!\n");
		return 1;
	}

	fgets(bottom_left, 20, fp);
	strtok(bottom_left, "\n");

	fp = fopen("bottom-right", "r");
	if (fp == NULL)
	{
		printf("Could not open file!\n");
		return 1;
	}

	fgets(bottom_right, 20, fp);
	strtok(bottom_right, "\n");

	char display_space_1[20];
	char display_space_2[20];

	if (strlen(top_left) + strlen(top_right) > 19)
	{
		printf("top_left + top_right is too long!\n");
		return 1;
	}
	else
	{
		int spaces1 = 19 - strlen(top_left) - strlen(top_right);

		printf("%d\n", spaces1);

		snprintf(display_space_1, 20, "%.*s", spaces1, "                    ");
	}

	if (strlen(bottom_left) + strlen(bottom_right) > 19)
	{
		printf("bottom_left + bottom_right is too long!\n");
		return 1;
	}
	else
	{
		int spaces2 = 19 - strlen(bottom_left) - strlen(bottom_right);

		printf("%d\n", spaces2);

		snprintf(display_space_2, 20, "%.*s", spaces2, "                    ");
	}

	char display_line_1[20];
	char display_line_2[20];

	snprintf(display_line_1, 20, "%s%s%s", top_left, display_space_1, top_right);
	snprintf(display_line_2, 20, "%s%s%s", bottom_left, display_space_2, bottom_right);

	printf(display_line_1);
	printf("\n");
	printf(display_line_2);
	printf("\n");

	ioctl(devfd, PLCM_IOCTL_SET_LINE, 1);
	write(devfd, display_line_1, strlen(display_line_1));
	ioctl(devfd, PLCM_IOCTL_SET_LINE, 2);
	write(devfd, display_line_2, strlen(display_line_2));

	close(devfd);

	return 0;
}
